<?php
class ControllerCommonDashboard extends Controller {
	public function index() {
		$this->load->language('common/dashboard');

		$this->document->setTitle($this->language->get('heading_title'));

		$data['heading_title'] = $this->language->get('heading_title');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);
		
		$data['token'] = $this->session->data['token'] ;

		// Check install directory exists
		if (is_dir(dirname(DIR_APPLICATION) . '/install')) {
			$data['error_install'] = $this->language->get('error_install');
		} else {
			$data['error_install'] = '';
		}

		// Dashboard Extensions
		$dashboards = array();

		$this->load->model('catalog/dashboard');
		$this->load->model('user/user');
		
		$userid = $this->session->data['user_id'];
		$user = $this->model_user_user->getUser($userid);
		$data['user_group']= $user['user_group_id'];

		
	    $data['recent_takeaway'] = $this->model_catalog_dashboard->getRecentTakeaway();
		$data['recent_table'] = $this->model_catalog_dashboard->getRecentTableOrder();
		
		 $recents = $this->model_catalog_dashboard->getRecentSales();
		 $data['recent_sale']=$recents['total_amount'];
		 
		$data['recent_purchase'] = $this->model_catalog_dashboard->getRecentPurchase();
		$data['recent_customer'] = $this->model_catalog_dashboard->getRecentCustomer();
		$data['recent_kots_closed'] = $this->model_catalog_dashboard->getRecentKotsClosed();
		$data['recent_kots_open'] = $this->model_catalog_dashboard->getRecentKotsOpen();
		
		$data['weekly_sales'] = $this->model_catalog_dashboard->getWeeklySales();
		$data['weekly_purchase'] = $this->model_catalog_dashboard->getWeeklyPurchase();
		
		$data['recent_orders'] = $recents['total_bills'];
		
		
	
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		// Run currency update
		if ($this->config->get('config_currency_auto')) {
			$this->load->model('localisation/currency');

			$this->model_localisation_currency->refresh();
		}

		$this->response->setOutput($this->load->view('common/dashboard', $data));
	}
	
	
public function refresh_dashboard(){
	    $this->load->model('catalog/dashboard');

	    $data['recent_takeaway'] = $this->model_catalog_dashboard->getRecentTakeaway();
		$data['recent_table'] = $this->model_catalog_dashboard->getRecentTableOrder();
		
		 $recents = $this->model_catalog_dashboard->getRecentSales();
		 $data['recent_sale']=$recents['total_amount'];
		 
		$data['recent_purchase'] = $this->model_catalog_dashboard->getRecentPurchase();
		$data['recent_customer'] = $this->model_catalog_dashboard->getRecentCustomer();
		$data['recent_kots_closed'] = $this->model_catalog_dashboard->getRecentKotsClosed();
		$data['recent_kots_open'] = $this->model_catalog_dashboard->getRecentKotsOpen();
		
		$data['recent_orders'] = $recents['total_bills'];
		
		print_r(json_encode($data));
	
	}	
	
}