<?php
class ModelSaleSaleOrder extends Model
{
    
    //get open tables
    public function getTakenTables()
    {
        $query = $this->db->query("SELECT table_id, table_order_id FROM " . DB_PREFIX . "table_orders where status = 'open'");
        return $query->rows;
    }

    public function getWaitingTables()
    {
        $query = $this->db->query("SELECT table_id, table_order_id FROM " . DB_PREFIX . "table_orders where status = 'waiting'");
        return $query->rows;
          
    }

    public function getLastBillNumber(){
        $query = $this->db->query("SELECT bill_number FROM oc_bill_number_to_bills ORDER BY bill_number_id DESC LIMIT 1;");
        return $query->rows;
      }


    //update table ids on table transfer
    public function updateTableId($table_order_id, $move_to_table_id){
        $query = $this->db->query("UPDATE oc_table_orders SET table_id = '" . $this->db->escape($move_to_table_id) . "' WHERE table_order_id = ".$table_order_id);
    }
    
    
    //update table ids on table transfer
    public function mergeTables($table_order_id_s, $table_order_id_d, $time){
        $query = $this->db->query("UPDATE oc_table_orders SET status = 'close', clear_time = '" . $this->db->escape($time) . "' where table_order_id = '" . $this->db->escape($table_order_id_s) . "'");
        $query = $this->db->query("UPDATE oc_table_orders_to_kot SET table_order_id = '".$this->db->escape($table_order_id_d)."' where table_order_id = '" . $this->db->escape($table_order_id_s) . "'");
    }
    

    //get initial kot data for table order
    public function getOpenKots()
    {
        $query = $this->db->query("SELECT tk.table_order_id, tod.table_id, tk.kot_id, k.time, k.notes FROM oc_table_orders_to_kot tk LEFT JOIN oc_kot k ON (tk.kot_id = k.kot_id) LEFT JOIN oc_table_orders tod ON (tk.table_order_id = tod.table_order_id) where k.status = 'open'");
        return $query->rows;
    }
    
    //update payment table orders
    public function updatePayment($payment_method, $bill_remark, $table_order_id, $time)
    {
        
        $query = $this->db->query("UPDATE oc_table_bills SET payment_method = '" . $this->db->escape($payment_method) . "', remarks ='". $this->db->escape($bill_remark) ."' WHERE table_order_id = ".$table_order_id);
        $query = $this->db->query("UPDATE oc_table_orders SET status = 'close', clear_time = '" . $this->db->escape($time) . "' where table_order_id = '" . $this->db->escape($table_order_id) . "'");
        $query = $this->db->query("UPDATE oc_kot ok left join oc_table_orders_to_kot tok ON (ok.kot_id = tok.kot_id) SET status = 'close' where tok.table_order_id = '" . $this->db->escape($table_order_id) . "'");
        
    }
      //update payment table orders
  
    public function updatePaymentTakeaway($payment_method, $bill_remark, $takeaway_order_id, $time)
    {
         
        $query = $this->db->query("UPDATE oc_takeaway_bills SET payment_method = '" . $this->db->escape($payment_method) . "', remarks ='". $this->db->escape($bill_remark) ."' WHERE takeaway_order_id = ".$takeaway_order_id);
        $query = $this->db->query("UPDATE oc_takeaway_orders SET status = 'close' where takeaway_order_id = '" . $this->db->escape($takeaway_order_id) . "'");
        $query = $this->db->query("UPDATE oc_kot ok left join oc_takeaway_to_kot tok ON (ok.kot_id = tok.kot_id) SET status = 'close' where tok.takeaway_order_id = '" . $this->db->escape($takeaway_order_id) . "'");
        
    }
   
    
    //cancel kot
    public function cancelKot($kot_id, $remark, $food_prep, $time, $date)
    {
        $query = $this->db->query("INSERT oc_canceled_kots SET kot_id = '" . $this->db->escape($kot_id) . "', food_prepared = '" . $this->db->escape($food_prep) . "', remarks = '" . $this->db->escape($remark) . "', time = '" . $this->db->escape($time) . "', date = '" . $this->db->escape($date) . "'");
        $query = $this->db->query("UPDATE oc_kot SET status = 'cancel' where kot_id = $kot_id ");
        $query = $this->db->query("UPDATE oc_kot_to_product SET canceled_status = '1' where kot_id = $kot_id ");
    }
    
    //cancel kot product
    public function cancelKotProduct($kot_to_product_id)
    {
        $query = $this->db->query("UPDATE oc_kot_to_product SET canceled_status = '1' where kot_to_product_id =$kot_to_product_id ");
    }
    
    //get waiting table orders
   
    public function tableBillsWaiting()
    {
        $query = $this->db->query("SELECT tb.table_order_id, tb.table_id, occ.firstname, occ.email, occ.telephone, tb.discount, tb.service_charges FROM oc_table_bills tb LEFT JOIN oc_customer occ ON (tb.customer_id = occ.customer_id ) where tb.payment_method = 'waiting'");
     
        return $query->rows;
        
    }


     //get waiting takeaway orders
     public function takeawayOrderWaiting()
     {
         $query = $this->db->query("SELECT tb.takeaway_order_id, occ.firstname, occ.email, occ.telephone, tb.discount, tb.service_charges FROM oc_takeaway_bills tb LEFT JOIN oc_customer occ ON (tb.customer_id = occ.customer_id ) where tb.payment_method = 'waiting'");
         return $query->rows;
     }
    
    
    //close table order    
    public function closeTableOrder($table_order_id)
    {
        $query = $this->db->query("UPDATE oc_table_orders SET status = 'cancel' where table_order_id = $table_order_id ");
    }
    
    //get initial kot data for takeaway order
    public function getOpenTakeawayKots()
    {
        $query = $this->db->query("SELECT tk.takeaway_order_id, tod.order_source_id, tk.kot_id, k.time FROM oc_takeaway_to_kot tk LEFT JOIN oc_kot k ON (tk.kot_id = k.kot_id) LEFT JOIN oc_takeaway_orders tod ON (tod.takeaway_order_id = tk.takeaway_order_id) where k.status = 'open' AND tod.order_source_id ='5'");
        return $query->rows;
        
    }
    
    
    //get initial kot data for takeaway order
    public function getAllOpenTakeawayKots()
    {
        $query = $this->db->query("SELECT tk.takeaway_order_id, k.notes, tod.order_source_id, tk.kot_id, k.time FROM oc_takeaway_to_kot tk LEFT JOIN oc_kot k ON (tk.kot_id = k.kot_id) LEFT JOIN oc_takeaway_orders tod ON (tod.takeaway_order_id = tk.takeaway_order_id) where k.status = 'open'");
        return $query->rows;
        
    }
    
    
    
    //get initial kot data for takeaway order
    public function getOpenSwiggyKots()
    {
        $query = $this->db->query("SELECT tk.takeaway_order_id, tod.order_source_id, tk.kot_id, k.time FROM oc_takeaway_to_kot tk LEFT JOIN oc_kot k ON (tk.kot_id = k.kot_id) LEFT JOIN oc_takeaway_orders tod ON (tod.takeaway_order_id = tk.takeaway_order_id) where k.status = 'open' AND tod.order_source_id in (1,2,3)");
        return $query->rows;
        
    }
    
    
    
    //get initial kot data for takeaway order
    public function getOpenHomeKots()
    {
        $query = $this->db->query("SELECT tk.takeaway_order_id, tk.kot_id, tod.order_source_id, k.time FROM oc_takeaway_to_kot tk LEFT JOIN oc_kot k ON (tk.kot_id = k.kot_id) LEFT JOIN oc_takeaway_orders tod ON (tod.takeaway_order_id = tk.takeaway_order_id) where k.status = 'open' AND tod.order_source_id = 4");
        return $query->rows;
    }
    
    
    
    //kot products
    public function getKotProducts($kot_ids)
    {
        $query = $this->db->query("SELECT  kot_id, product_id, price, name, canceled_status, kot_to_product_id, kp.tax_class, tc.title, quantity, category_id FROM " . DB_PREFIX . "kot_to_product kp LEFT JOIN oc_tax_class tc ON (kp.tax_class = tc.tax_class_id) where kot_id IN  (" . $kot_ids . ")");
        return $query->rows;
        
    }
    
    //get recent kot data
    public function getLastKot()
    {
        $query = $this->db->query("SELECT table_order_id, k.kot_id, k.notes, time FROM " . DB_PREFIX . "kot k LEFT JOIN oc_table_orders_to_kot tk ON (k.kot_id = tk.kot_id) where status = 'open' ORDER BY k.kot_id DESC LIMIT 1");
        return $query->rows;
        
    }
    
    //get customers
    public function getSaleCustomer()
    {
        $sql = "SELECT customer_id, firstname, email, telephone from oc_customer";
        
        $query = $this->db->query($sql);
        return $query->rows;
        
        
    }
    
    
    //get recent kot data
    public function getLastKotTakeaway()
    {
        $query = $this->db->query("SELECT takeaway_order_id, k.kot_id, time FROM " . DB_PREFIX . "kot k LEFT JOIN oc_takeaway_to_kot tk ON (k.kot_id = tk.kot_id) where status = 'open' ORDER BY k.kot_id DESC LIMIT 1");
        return $query->rows;
        
    }
    
    //getPaymentMethods
    public function getPaymentMethods()
    {
        $query = $this->db->query("SELECT * from oc_payment_methods");
        return $query->rows;
        
    }
    
    //get waiter
    public function getWaiters()
    {
        $query = $this->db->query("SELECT * from oc_waiter_list");
        return $query->rows;
        
    }
    
    //get waiter
    public function getOrderSources()
    {
        $query = $this->db->query("SELECT * from oc_order_source_list");
        return $query->rows;
        
    }
    
    
    public function getLastKotProducts($kot_ids)
    {
        $query = $this->db->query("SELECT  kot_id, product_id, kot_to_product_id, canceled_status, price, name, quantity, category_id FROM " . DB_PREFIX . "kot_to_product where kot_id = '" . $kot_ids . "'");
        return $query->rows;
        
    }
    
    
    
    
    //save table bill
    public function save_table_bill($data)
    {
        
        $query = $this->db->query("INSERT into oc_table_bills SET created_by = '" . $this->db->escape($data['created_by']) . "', bill_number = '" . $this->db->escape($data['bill_number']) . "', date = '" . $this->db->escape($data['date']) . "', time = '" . $this->db->escape($data['time']) . "', grand_total = '" . $this->db->escape($data['grand_total']) . "',sub_total = '" . $this->db->escape($data['sub_total']) . "',tax_total = '" . $this->db->escape($data['tax_total']) . "', service_charges = '" . $this->db->escape($data['service_charges']) . "', discount = '" . $this->db->escape($data['discount']) . "', payment_method = '" . $this->db->escape($data['payment_method']) . "', served_by = '" . $this->db->escape($data['served_by']) . "', erase_flag = '" . $this->db->escape($data['erase_flag']) . "',  table_order_id = '" . $this->db->escape($data['table_order_id']) . "', customer_id = '" . $this->db->escape($data['customer_id']) . "', table_id = '" . $this->db->escape($data['table_id']) . "'");
        $table_bill_id = $this->db->getLastId();
       
        $query = $this->db->query("UPDATE oc_table_orders SET status = 'waiting' WHERE table_order_id = ".$data['table_order_id']);
        $query = $this->db->query("INSERT into oc_bill_number_to_bills SET bill_number = '" . $this->db->escape($data['bill_number']) . "', table_bill_id = '" . $this->db->escape($table_bill_id) . "', takeaway_bill_id = '0'");
       

        for ($i = 0; $i < sizeof($data['product_id']); $i++) {
            $query = $this->db->query("INSERT into oc_table_bills_to_product SET table_bill_id = '" . $this->db->escape($table_bill_id) . "', product_id = '" . $this->db->escape($data['product_id'][$i]) . "', category_id = '" . $this->db->escape($data['category_id'][$i]) . "', canceled_status = '" . $this->db->escape($data['cancel_status'][$i]) . "', tax = '".$this->db->escape($data['product_tax'][$i])."', name ='" . $this->db->escape($data['product_name'][$i]) . "', price ='" . $this->db->escape($data['product_price'][$i]) . "', quantity ='" . $this->db->escape($data['product_qty'][$i]) . "'");
        }
    }
    
    
    
    
    //takeaway bill
    
    public function save_takeaway_bill($data)
    {
        
        $query = $this->db->query("INSERT into oc_takeaway_bills SET created_by = '" . $this->db->escape($data['created_by']) . "', bill_number = '" . $this->db->escape($data['bill_number']) . "', date = '" . $this->db->escape($data['date']) . "', time = '" . $this->db->escape($data['time']) . "', grand_total = '" . $this->db->escape($data['grand_total']) . "',sub_total = '" . $this->db->escape($data['sub_total']) . "',tax_total = '" . $this->db->escape($data['tax_total']) . "', order_source = '" . $this->db->escape($data['order_source']) . "', service_charges = '" . $this->db->escape($data['service_charges']) . "', discount = '" . $this->db->escape($data['discount']) . "', payment_method = '" . $this->db->escape($data['payment_method']) . "', served_by = '" . $this->db->escape($data['served_by']) . "', takeaway_order_id ='" . $this->db->escape($data['takeaway_order_id']) . "', erase_flag = '" . $this->db->escape($data['erase_flag']) . "', customer_id = '" . $this->db->escape($data['customer_id']) . "'");
        
        $takeaway_bill_id = $this->db->getLastId();
        $query = $this->db->query("UPDATE oc_takeaway_orders SET status = 'waiting' WHERE takeaway_order_id = ".$data['takeaway_order_id']);
    
        $query = $this->db->query("INSERT into oc_bill_number_to_bills SET bill_number = '" . $this->db->escape($data['bill_number']) . "', table_bill_id = '0', takeaway_bill_id = '" . $this->db->escape($takeaway_bill_id) . "'");
       
        
        for ($i = 0; $i < sizeof($data['product_id']); $i++) {
            $query = $this->db->query("INSERT into oc_takeaway_to_products SET takeaway_bill_id = '" . $this->db->escape($takeaway_bill_id) . "', product_id = '" . $this->db->escape($data['product_id'][$i]) . "', tax = '".$this->db->escape($data['product_tax'][$i])."', name ='" . $this->db->escape($data['product_name'][$i]) . "', price ='" . $this->db->escape($data['product_price'][$i]) . "', quantity ='" . $this->db->escape($data['product_qty'][$i]) . "'");
        }
      
    }
    
    
    
    
    public function getCategories($parent_id = 0)
    {
        $query = $this->db->query("SELECT * FROM " . DB_PREFIX . "category c LEFT JOIN " . DB_PREFIX . "category_description cd ON (c.category_id = cd.category_id) LEFT JOIN " . DB_PREFIX . "category_to_store c2s ON (c.category_id = c2s.category_id) WHERE c.parent_id = '" . (int) $parent_id . "' AND cd.language_id = '" . (int) $this->config->get('config_language_id') . "' AND c2s.store_id = '" . (int) $this->config->get('config_store_id') . "'  AND c.status = '1' ORDER BY c.sort_order, LCASE(cd.name)");
        
        return $query->rows;
    }
    
    public function getProducts()
    {
        $query = $this->db->query("SELECT p.product_id, quantity, price, tax_class_id, subtract, name, category_id from oc_product p LEFT JOIN oc_product_description pd ON (p.product_id = pd.product_id) LEFT JOIN oc_product_to_category p2c ON (p.product_id = p2c.product_id)");
        return $query->rows;
        
    }
    
    public function getProductsByCategories($categories_ids)
    {
        $query = $this->db->query("SELECT p.product_id, quantity, price, tax_class_id, subtract, name, category_id from oc_product p LEFT JOIN oc_product_description pd ON (p.product_id = pd.product_id) LEFT JOIN oc_product_to_category p2c ON (p.product_id = p2c.product_id) WHERE category_id in ($categories_ids)");
        return $query->rows;
        
    }
    


    public function insertTableOrder($data)
    {
        
        $query = $this->db->query("INSERT into oc_table_orders SET table_id = '" . $this->db->escape($data['table_id']) . "', open_time = '" . $this->db->escape($data['open_time']) . "', date ='" . $this->db->escape($data['date']) . "', open_by ='" . $this->db->escape($data['open_by']) . "', status ='" . $this->db->escape($data['status']) . "'");
        
        return $this->db->getLastId();
        
    }
    
    
    public function insertTakeawayOrder($data)
    {
        
        $query = $this->db->query("INSERT into oc_takeaway_orders SET customer_id = '" . $this->db->escape($data['customer_id']) . "', order_open_time = '" . $this->db->escape($data['order_open_time']) . "', date ='" . $this->db->escape($data['date']) . "', open_by ='" . $this->db->escape($data['open_by']) . "', status ='" . $this->db->escape($data['status']) . "', order_source_id ='" . $this->db->escape($data['order_source_id']) . "'");
        
        return $this->db->getLastId();
        
    }
    
    
    
    public function insertKot($data)
    {
        
        $query = $this->db->query("INSERT into oc_kot SET total_amount = '" . $this->db->escape($data['total']) . "', notes = '" . $this->db->escape($data['notes']) . "', time = '" . $this->db->escape($data['time']) . "', date ='" . $this->db->escape($data['date']) . "', created_by ='" . $this->db->escape($data['created_by']) . "', status ='" . $this->db->escape($data['status']) . "'");
        
        $kot_id = $this->db->getLastId();
        
        for ($i = 0; $i < sizeof($data['product_id']); $i++) {
            $query = $this->db->query("INSERT into oc_kot_to_product SET kot_id = '" . $this->db->escape($kot_id) . "', product_id = '" . $this->db->escape($data['product_id'][$i]) . "', name ='" . $this->db->escape($data['product_name'][$i]) . "', price ='" . $this->db->escape($data['product_price'][$i]) . "', quantity ='" . $this->db->escape($data['product_qty'][$i]) . "', category_id ='" . $this->db->escape($data['category_id'][$i]) . "' , tax_class ='" . $this->db->escape($data['product_tax'][$i]) . "'");
        }
        return $kot_id;
        
    }
    
    public function mapTableToKot($table_order_id, $kot_id)
    {
        $query = $this->db->query("INSERT into oc_table_orders_to_kot SET table_order_id = '" . $this->db->escape($table_order_id) . "', kot_id = '" . $this->db->escape($kot_id) . "'");
    }
    
    
    public function mapTakeawayToKot($takeaway_order_id, $kot_id)
    {
        $query = $this->db->query("INSERT into oc_takeaway_to_kot SET takeaway_order_id = '" . $this->db->escape($takeaway_order_id) . "', kot_id = '" . $this->db->escape($kot_id) . "'");
        
    }
    
    
    public function addCustomer($customer_name, $customer_email, $customer_phone)
    {
        $salt     = token(9);
        $password = '12345';
        
        $query       = $this->db->query("INSERT into oc_customer SET customer_group_id = '1', store_id = '0', language_id = '1', firstname = '" . $this->db->escape($customer_name) . "', email = '" . $this->db->escape($customer_email) . "', telephone = '" . $this->db->escape($customer_phone) . "', password = '" . $this->db->escape(sha1($salt . sha1($salt . sha1($password)))) . "', salt = '" . $this->db->escape($salt) . "'");
        $customer_id = $this->db->getLastId();
        return $customer_id;
        
        
    }
    
    
}

?>